/* $XFree86: $ */


/* All drivers should typically include these */
#include "xf86.h"
#include "xf86_OSproc.h"
#include "xf86_ansic.h"

/* For correct __inline__ usage */
#include "compiler.h"

/* Drivers that need to access the PCI config space directly need this */
#include "xf86Pci.h"

/* Drivers for PCI hardware need this */
#include "xf86PciInfo.h"

/* Drivers that use XAA need this */
#include "xaa.h"
#include "xaalocal.h"
#include "xaarop.h"		//HSU
#include "xf86fbman.h"
#include "miline.h"
#include "servermd.h"

#define MAX_IDLE_LOOP   0x7FFFFFFUL
// #define CHECK_NOTBUSY -- defined in mqplat.h
// #define CHECK_CMDFIFO -- defined in mqplat.h

#include "mq.h"
#include "mqplat.h"
#include "mq2hw.h"
#include "mq_ge.h"


#if CLIPPER_ON != 0x2
#pragma message ("CLipper_on not 0x2!!!")
#pragma warning (error : 9999)
#else
//Bit 26 of DRAW_CMD subtract bit 1 of CLIPPER_ON
#define ENABLE_CLIP_SHIFT       25
#endif


#ifdef CLIP_SOLIDFILL
#define CHECK_CLIP_SOLIDFILL( cmd ) \
        cmd |= ((pMQ->AccelFlags & CLIPPER_ON) << ENABLE_CLIP_SHIFT);
#else
#define CHECK_CLIP_SOLIDFILL( cmd )
#endif

/*
static ULONG	Rop2List[16] =
{ 0x00UL, 0x05UL, 0x0AUL, 0x0FUL, 0x50UL, 0x55UL, 0x5AUL, 0x5FUL,
  0xA0UL, 0xA5UL, 0xAAUL, 0xAFUL, 0xF0UL, 0xF5UL, 0xFAUL, 0xFFUL };
 */

#if 0
static ULONG	Rop2PatList[16] =
{ 0x00UL, 0xA0UL, 0x50UL, 0xF0UL, 0x05UL, 0xAAUL, 0x5AUL, 0xFAUL,
  0x05UL, 0xA5UL, 0x55UL, 0xF5UL, 0x0FUL, 0xAFUL, 0x5FUL, 0xFFUL };

static ULONG	Rop2SrcList[16] =
{ 0x00UL, 0x88UL, 0x44UL, 0xCCUL, 0x22UL, 0xAAUL, 0x66UL, 0xEEUL,
  0x11UL, 0x99UL, 0x55UL, 0xDDUL, 0x33UL, 0xBBUL, 0x77UL, 0xFFUL };
#endif

//#pragma optimize("", off)

#ifdef CHECK_SRCFIFO
static void
WaitSrcFIFO( MQPtr pMQ, int cnt )
{
}
#endif


#ifdef CHECK_CMDFIFO
static void
WaitCmdFIFO( MQPtr pMQ, int fifoNeeded )
{
    ULONG	status;
    ULONG       cnt = 0UL;
    for( ;; )
    {
    	status = cpuREAD(DRAW_STATUS);
	if ( (status & CMD_FIFO_MASK) >= fifoNeeded )
	    break;
    	cnt++;
    	if ( cnt >= MAX_IDLE_LOOP )
    	{
            ErrorF("WaitCmdFIFO: Need 0x%x. Status: 0x%x. GE Reset.\n",
	    	fifoNeeded, status);
            status = pmuREAD( PM_MISC );
            pmuREG( PM_MISC, (status & ~GE_ENABLE) );
            pmuREG( PM_MISC, (status | GE_ENABLE) );
	    break;
        }
    }
}
#endif

#define	MACRO_WAITNOTBUSY \
{ \
    ULONG	status; \
    ULONG       cnt = 0UL; \
    for( ;; ) \
    { \
    	status = cpuREAD(DRAW_STATUS); \
    	/*if ( (status & (GE_BUSY|CMD_FIFO_MASK|SRC_FIFO_MASK)) */ \
	/*		== (SRC_FIFO_EMPTY | CMD_FIFO_EMPTY) )  */ \
    	if ( !(status & GE_BUSY) ) \
	    break; \
    	cnt++; \
    	if ( cnt >= MAX_IDLE_LOOP ) \
    	{ \
            ErrorF("WaitNotBusy: Never reset with %x.  GE Reset.\n", status); \
            status = pmuREAD( PM_MISC ); \
            pmuREG( PM_MISC, (status & ~GE_ENABLE) ); \
            pmuREG( PM_MISC, (status | GE_ENABLE) ); \
	    break; \
        } \
    } \
}

#ifdef CHECK_NOTBUSY
static void
WaitNotBusy( MQPtr pMQ )
{
    MACRO_WAITNOTBUSY
}
#endif	//CHECK_NOTBUSY

//#pragma optimize("", on)

void
MQSync(ScrnInfoPtr pScrn) 
{
    MQPtr pMQ = MQPTR(pScrn);

    //geWAITNOTBUSY;
    MACRO_WAITNOTBUSY
 
#if 0
    if(pMQ->AccelFlags & CLIPPER_ON)
    {
        //Looks like we need to clear the clip flag
        pMQ->AccelFlags &= ~CLIPPER_ON;
    }
#endif
}

void
MQCPUToScreenSync(ScrnInfoPtr pScrn) 
{
    MQPtr pMQ = MQPTR(pScrn);
 
    if ( pMQ->Need64BitDummy )
    {
	*(pMQ->SrcImageDataAddr)     = 0;
	*(pMQ->SrcImageDataAddr+1)   = 0;
        pMQ->Need64BitDummy = 0;
    }

    pMQ->AccelInfoRec->Sync = MQSync;
}

void MQSetClippingRectangle(
   ScrnInfoPtr pScrn,
   int x1, int y1, int x2, int y2       //l, t, r, b
)
{
    MQPtr pMQ = MQPTR(pScrn);
    //ErrorF("MQSetClippingRectangle: %d,%d,%d,%d\n", x1, y1, x2, y2);
    //pMQ->ClipLeftT = ((y1 << 16) | x1);      
    //pMQ->ClipRightB = ((y2 << 16) | x2);
    geWAITCMDFIFO(2);
    geREG_2( CLIP_LeftT,  ((y1 << 16) | x1),
    	     CLIP_RightB, ((y2 << 16) | x2) );
    pMQ->AccelFlags |= CLIPPER_ON;
}

void MQDisableClipping(ScrnInfoPtr pScrn)
{
    MQPtr pMQ = MQPTR(pScrn);
    //ErrorF("MQDisableClipping\n");
    //Don't do anything else clear clip_is_on flag
    pMQ->AccelFlags &= ~CLIPPER_ON;
}


	/*********************************************\
	|            Screen-to-Screen Copy            |
	\*********************************************/

void 
MQSetupForScreenToScreenCopy(
    ScrnInfoPtr pScrn,
    int xdir, int ydir,
    int rop,
    unsigned int planemask,
    int trans 
)
{
    MQPtr pMQ = MQPTR(pScrn);

    //ErrorF("MQSetupForScreenToScreenCopy:0x%x,0x%x,%d,%d\n",
    //                  rop, trans, xdir, ydir);

    //Assuming negative dir is always -1 and positive dir is +1
    pMQ->DrawCommand = ((((ydir - 1) & 0x04) + ((xdir - 1) & 0x02)) << 10)
                        //+ Rop2SrcList[rop]
                        + XAACopyROP[rop]
                        + ((pMQ->AccelFlags & CLIPPER_ON) << ENABLE_CLIP_SHIFT)
                        + DO_BITBLT;

    //DrawTransparent comes from DGA
    //if(pMQ->DrawTransparent)
 /*
  * Unfortunately, our hardware defines color compare to the
  * results rather to the source.  Can't use it here.
    if( trans != -1 )   //I thought this is what the spec says
    { 
	geWAITCMDFIFO(2);
	geREG_2(FG_COLOR, trans,
		BG_COLOR, ~trans);
        pMQ->DrawComamnd |= TRANS_COLOR;
    }
  */
}

void 
MQSubsequentScreenToScreenCopy(
    ScrnInfoPtr pScrn,
    int srcX, int srcY, int dstX, int dstY, int w, int h
)
{
    MQPtr pMQ = MQPTR(pScrn);
    ULONG cmd = pMQ->DrawCommand;

    if (cmd & X_DIR)
    {
        srcX += w - 1;
        dstX += w - 1;
    }
    if (cmd & Y_DIR)
    {
        srcY += h - 1;
        dstY += h - 1;
    }

    geWAITCMDFIFO(4); 
    geREG_3(WIDTH_HEIGHT, (h << 16 | w),
    	    DEST_XY, (dstY << 16 | dstX),
    	    SRC_XY, (srcY << 16 | srcX));
    geREG(DRAW_CMD, cmd); 
}

        /******************\
	|   Solid Fills    |
	\******************/

void 
MQSetupForSolidFill(
	ScrnInfoPtr pScrn,
	int color,
	int rop,
	unsigned int planemask )
{
    MQPtr pMQ = MQPTR(pScrn);

    int mix;
    //int orop = rop;

    mix = XAAHelpSolidROP(pScrn, &color, planemask, &rop);

#if 0
    pMQ->DrawCommand = rop;
    if (pMQ->AccelFlags & CLIPPER_ON)
        pMQ->DrawCommand |= CLIP_ENABLE;
#else
    pMQ->DrawCommand = rop;
    CHECK_CLIP_SOLIDFILL( (pMQ->DrawCommand) )
#endif
 
    if(mix & ROP_SRC)
    {
   	//ErrorF("MQSetupForSolidFill src: %x,%x,%x\n", mix, rop, planemask);
	pMQ->DrawCommand |= MONO_SOLID | MONO_SRC;
	geWAITCMDFIFO(2);
	geREG(FG_COLOR, planemask);
    }
    else
    {
	geWAITCMDFIFO(1);
    }

    if(mix & ROP_PAT)
    {
	pMQ->DrawCommand |= MONO_PATTERN | MONO_SOLID;
	geREG(PAT_FG_COLOR, color);
    }
}

void 
MQSubsequentSolidFillRect(
	ScrnInfoPtr pScrn,
	int x, int y, int w, int h )
{
    MQPtr pMQ;
    if ( w == 0 || h== 0 )
    {
        //XAA does not check for these 2 conditions which our
        //GE will go beserk.
    	return;
    }

    pMQ = MQPTR(pScrn);
    geWAITCMDFIFO(3);
    geREG_2(WIDTH_HEIGHT, ((h << 16) | w),
    	    DEST_XY,      ((y << 16) | x));
    geREG(  DRAW_CMD,     (DO_BITBLT | pMQ->DrawCommand));
}

void 
MQSubsequentSolidHorVertLine(
    ScrnInfoPtr pScrn,
    int x, int y, 
    int len, int dir
)
{
    MQPtr pMQ;
    ULONG	wh;

/*
    HSU: So far, these non 0 or 270 degree do not exist.  So is 0 length case.
    if ( !(dir == DEGREES_0 || dir == DEGREES_270) || len == 0 )
    {
        ErrorF("HorVer: %d,%d,%d,%d\n", x, y, len, dir);
        return;
    }
*/
    pMQ = MQPTR(pScrn);
    if(dir == DEGREES_0)
	wh = 0x10000 + len;
    else
	wh = (len << 16) + 1;
    geWAITCMDFIFO(3);
    geREG_2( WIDTH_HEIGHT, wh,
    	     DEST_XY,      ((y << 16) | x) );
    geREG(   DRAW_CMD,     (DO_BITBLT | pMQ->DrawCommand));
}

/*
    XDECREASING	    4	Draw from right to left (a.o.t. right to left).
    YDECREASING	    2	Draw from bottom to top (top to bottom).
    YMAJOR	    1	Y is the major axis (X is the major axis).

    The error terms are usually no bigger than a screen coordinate, but
    when software clipping is used, the error time might be too big; it
    is then rescaled according to the number of bits specified in
    ErrorTermBits. When HARDWARE_CLIP_LINE is defined,
    SetClippingRectangle must be defined. It seems to me that hardware
    clipping makes the implicit assumption that the chip can handle
    coordinates in the range [-37268, 32767]. Or are coordinates
    guaranteed to be on-screen? Anyway I think having the chip trace
    lines way off the screen does not sound like a good idea.

    There is no SetUp function. SetupForFillRectSolid is called before
    a batch of lines (this linked to the fact that horizontal lines
    are drawn with FillRectSolid; they should not be affected by
    hardware clipping).

*/

#define LINE_YMAJOR_SHIFT    (29 - 0)
#if YMAJOR != 1
#pragma message ("Line Y_MAJOR not 0x1!!!")
#pragma warning (error : 9998)
#endif
#define LINE_XDIR_SHIFT      (11 - 2)
#if XDECREASING != 4
#pragma message ("Line XDECREASING not 0x4!!!")
#pragma warning (error : 9997)
#endif
#define LINE_YDIR_SHIFT      (12 - 1)
#if YDECREASING != 2
#pragma message ("Line YDECREASING not 0x2!!!")
#pragma warning (error : 9996)
#endif

void
MQSubsequentSolidBresenhamLine(
    ScrnInfoPtr pScrn,
    int x, int y,
    int absmaj, int absmin,
    int err, int len, int octant)
{
    MQPtr       pMQ = MQPTR( pScrn );

    geWAITCMDFIFO( 4 );
    geREG_3(LINE_DRAW,    (((ULONG)err & 0x1FFFFUL)
			  | ((len & 0xFFF) << 17)
			  | (((octant & YMAJOR) << LINE_YMAJOR_SHIFT))),
    	    LINE_MAJOR_X, (x | ((absmaj & 0x1FFFFUL) << 12)),
    	    LINE_MINOR_Y, (y | ((absmin & 0x1FFFFUL) << 12)));
    geREG(  DRAW_CMD,     (DO_LINEDRAW | 0x40000000       //no last pixel
                          | ((octant & XDECREASING) << LINE_XDIR_SHIFT)
                          | ((octant & YDECREASING) << LINE_YDIR_SHIFT)
                          | pMQ->DrawCommand));

    //Need to take care of bug where srcfifo might hang the system.
    if (( (err & 0xFFF) >> 4) <= len )
    {
        geWAITCMDFIFO(3);
#if !defined(MQ_X86) && !defined(MQ_PCI)
        //Do a dummy 1x1 rectangle fill that xor with 0s
        //Effectively, this gives a no-op.
        //geREG_2(WIDTH_HEIGHT, 0x00010001,
        //	  FG_COLOR, 0x0);
        //geREG(  DRAW_CMD, (DO_BITBLT | MONO_SOLID | MONO_SRC | 0x66));
#else
        //Do a dummy 1x1 rectangle fill that nxor with 1s
        //Effectively, this gives a no-op.  x86 based compiler likes
	//to use AND op when doing a write of constant 0.  Thus use
	//1s and nxor to perform this no-op so that a read on PCI
	//bus can be avoided.
        geREG_2(WIDTH_HEIGHT, 0x00010001,
                FG_COLOR, 0xFFFFFFFF);
        geREG(  DRAW_CMD, (DO_BITBLT | MONO_SOLID | MONO_SRC | 0x99));
#endif
    }
}

#if 0
//Came from S3virge driver.  May not be necessary.
void 
MQVPolylinesThinSolidWrapper(
   DrawablePtr     pDraw,
   GCPtr           pGC,
   int             mode,
   int             npt,
   DDXPointPtr     pPts
)
{
    XAAInfoRecPtr infoRec = GET_XAAINFORECPTR_FROM_GC(pGC);
    MQPtr pMQ = MQPTR(infoRec->pScrn);
    if(infoRec->NeedToSync) 
    {
	geWAITNOTBUSY;
    }
    XAAPolyLines(pDraw, pGC, mode, npt, pPts);
}

//Came from S3.  May not be necessary.
void 
MQVPolySegmentThinSolidWrapper(
   DrawablePtr     pDraw,
   GCPtr           pGC,
   int             nseg,
   xSegment        *pSeg
)
{
    XAAInfoRecPtr infoRec = GET_XAAINFORECPTR_FROM_GC(pGC);
    MQPtr pMQ = MQPTR(infoRec->pScrn);
    if(infoRec->NeedToSync) 
    {
	geWAITNOTBUSY;
    }
    XAAPolySegment(pDraw, pGC, nseg, pSeg);
}
#endif

void 
MQSetupForMono8x8PatternFill(
    ScrnInfoPtr pScrn,
    int patx, int paty,
    int fg, int bg,
    int rop,
    unsigned int planemask )
{
    MQPtr pMQ = MQPTR(pScrn);
    int   mix;        

    mix = XAAHelpPatternROP(pScrn, &fg, &bg, planemask, &rop);

    pMQ->DrawCommand = DO_BITBLT
                     | rop
                     | ((pMQ->AccelFlags & CLIPPER_ON) << ENABLE_CLIP_SHIFT);

    if ( mix & ROP_SRC )
    {
        //ErrorF("MQSetupForMono8x8PatternFill src: %x\n", rop);
	geWAITCMDFIFO(5);
        geREG( FG_COLOR, planemask );
    }
    else
	geWAITCMDFIFO(4);

    if ( mix & ROP_PAT )
    {
        pMQ->DrawCommand |= MONO_PATTERN;
        geREG_4( MONO_PATTERN0, patx,     //mono 8x8 data in setup pass
        	 MONO_PATTERN1, paty,
        	 PAT_FG_COLOR, fg,
        	 PAT_BG_COLOR, bg );
    }
}


void 
MQSubsequentMono8x8PatternFillRect(
    ScrnInfoPtr pScrn,
    int patx, int paty,
    int x, int y, int w, int h )
{
    MQPtr pMQ = MQPTR(pScrn);
    
    geWAITCMDFIFO(3);
    geREG_2( WIDTH_HEIGHT, ((h << 16) | w),
    	     DEST_XY,      ((y << 16) | x | (paty << 29) | (patx << 13)));
    geREG(   DRAW_CMD,     pMQ->DrawCommand);
}


void 
MQSetupForCPUToScreenColorExpandFill (
	ScrnInfoPtr pScrn,
	int fg, int bg,
	int rop,
	unsigned int planemask )
{
    MQPtr pMQ = MQPTR(pScrn);

    planemask &= pMQ->FullPlaneMask;
    pMQ->DrawCommand = DO_BITBLT | MONO_SRC | SRC_IS_MEMORY
    			| CLIP_ENABLE | PACKED_MODE;
 
    if (planemask == pMQ->FullPlaneMask)
    {
        pMQ->DrawCommand |= XAACopyROP[rop];
        geWAITCMDFIFO(1);
    }
    else
    {
        pMQ->DrawCommand |= MONO_PATTERN | XAACopyROP_PM[rop];
        geWAITCMDFIFO(4);
        geREG_3( MONO_PATTERN0, ~0,
        	 MONO_PATTERN1, ~0,
        	 PAT_FG_COLOR, planemask );
    }
    if(bg == -1)
    {
    	geREG(FG_COLOR, fg);
        pMQ->DrawCommand |= TRANS_MONO;
    }
    else
    {
    	geREG_2( FG_COLOR, fg,
    		 BG_COLOR, bg );
    }
}

void 
MQSubsequentCPUToScreenColorExpandFill(
	ScrnInfoPtr pScrn,
	int x, int y, int w, int h,
	int skipleft
)
{
    ULONG neww, destxy; 
    MQPtr pMQ = MQPTR(pScrn);

    //If there's a previous SubsequentCPUToScreenColorExpandFill that
    //need extra 64bit of dummies to fill 128bit, we will do it here.
    //Need64BitDummy will be cleared by the setting following these dummies
    if ( pMQ->Need64BitDummy )
    {
	*pMQ->SrcImageDataAddr = 0;
	*(pMQ->SrcImageDataAddr+1) = 0;
    }
    pMQ->AccelInfoRec->Sync = MQCPUToScreenSync;

    neww = (w + 31) & ~31;
    pMQ->Need64BitDummy = ((neww * h) + 32) & 64;

    h = h << 16;
    destxy = (y << 16) | x;

    geWAITCMDFIFO(6);
    geREG_4( WIDTH_HEIGHT,         (h | neww),
    	     DEST_XY,              destxy,
    	     CLIP_LeftT,           (destxy + skipleft),
    	     CLIP_RightB,          (destxy + h + w - 0x00010001) );
    geREG(   SRC_STRIDE_OFFSET,    0 );
    geREG(   DRAW_CMD,             pMQ->DrawCommand);
}


void 
MQSetupForImageWrite (
	ScrnInfoPtr pScrn,
	int rop,
	unsigned int planemask,
	int transparency_color,
        int bpp,
        int depth)
{
    MQPtr pMQ = MQPTR(pScrn);

    planemask &= pMQ->FullPlaneMask;
    pMQ->DrawCommand = DO_BITBLT | SRC_IS_MEMORY | CLIP_ENABLE | PACKED_MODE;
 
    if (planemask == pMQ->FullPlaneMask)
    {
        pMQ->DrawCommand |= XAACopyROP[rop];
    }
    else
    {
        pMQ->DrawCommand |= MONO_PATTERN | XAACopyROP_PM[rop];
        geWAITCMDFIFO(3);
        geREG_3( MONO_PATTERN0, ~0,
        	 MONO_PATTERN1, ~0,
        	 PAT_FG_COLOR, planemask );
    }
}

void 
MQSubsequentImageWrite(
	ScrnInfoPtr pScrn,
	int x, int y, int w, int h,
	int skipleft
)
{
    ULONG neww, destxy; 
    MQPtr pMQ = MQPTR(pScrn);
    pMQ->AccelInfoRec->Sync = MQCPUToScreenSync;

    //If there's a previous SubsequentImageWrite that need extra
    //64bit of dummies to fill 128bit, we will do it here.
    //Need64BitDummy will be cleared by the setting following these dummies
    if ( pMQ->Need64BitDummy )
    {
	*pMQ->SrcImageDataAddr = 0;
	*(pMQ->SrcImageDataAddr+1) = 0;
    }

    neww = ((w << pMQ->BppShift) + 3) & ~3;	//in bytes aligned to 32bit
    pMQ->Need64BitDummy = ((neww * h) + 4) & 8;
    neww = neww >> pMQ->BppShift;

    h = h << 16;
    destxy = (y << 16) | x;

    geWAITCMDFIFO(6);
    geREG_4( WIDTH_HEIGHT,         (h | neww),
    	     DEST_XY,              destxy,
    	     CLIP_LeftT,         	(destxy + skipleft),
    	     CLIP_RightB,          (destxy + h + w - 0x00010001) );
    geREG(   SRC_STRIDE_OFFSET,    0 );
    geREG(   DRAW_CMD,             pMQ->DrawCommand );
}

	/***********************************\
	|  Screen to Screen Color Expansion |
	\***********************************/

void 
MQSetupForScreenToScreenColorExpandFill(
   ScrnInfoPtr pScrn,
   int fg, int bg, 
   int rop,
   unsigned int planemask
)
{
    MQPtr pMQ = MQPTR(pScrn);

    //We will use lined mode for our screen-to-screen color expansion
    //XAA claims to use screen pitch for src, thus make sure
    //src_not_equal_dst_stride bit is clear
    pMQ->DrawCommand = DO_BITBLT | MONO_SRC
                     //| ((pMQ->AccelFlags & CLIPPER_ON) << ENABLE_CLIP_SHIFT)
		     | CLIP_ENABLE
		     ;
 
    planemask &= pMQ->FullPlaneMask;

    if (planemask == pMQ->FullPlaneMask)
    {
        pMQ->DrawCommand |= XAACopyROP[rop];
        geWAITCMDFIFO(2);
    }
    else
    {
        pMQ->DrawCommand |= MONO_PATTERN | XAACopyROP_PM[rop];
        geWAITCMDFIFO(4);
        geREG_3( MONO_PATTERN0, ~0,
        	 MONO_PATTERN1, ~0,
        	 PAT_FG_COLOR, planemask );
    }
    if(bg == -1)
    {
    	geREG(FG_COLOR, fg);
	pMQ->DrawCommand |= TRANS_MONO;
    }
    else
    {
    	geREG_2( FG_COLOR, fg,
		 BG_COLOR, bg );
    }
}

void 
MQSubsequentScreenToScreenColorExpandFill(
   ScrnInfoPtr pScrn,
   int x, int y, int w, int h,
   int srcx, int srcy, 
   int skipleft
)
{
    //HSU: We always assume w and/or h will never be 0.
    //	   Also assume skipleft is < 32 bit.
    MQPtr pMQ = MQPTR(pScrn);
    ULONG	wh, dxy, nw;
    wh = ((h << 16) | w) - 0x00010001;
    dxy = (y << 16) | x;

    //GE Bug: Need to skip to next 128bit when approaching last bits within
    //	      128bit boundary
    if ( (((w + skipleft - 1) >> (4 - pMQ->BppShift)) & pMQ->BppBitMask)
    		== pMQ->BppBitMask )
	w += (16 >> pMQ->BppShift);
    //GE Bug: MIU requires extra read when offset+w exceeding 128 while
    //        w is < 128
    nw = (w + 127) & ~127;
    if ( (w + skipleft) > nw )
	w = nw + 1;

    geWAITCMDFIFO( 7 );
    geREG_5( WIDTH_HEIGHT,       ((h << 16) | w),		//new w
    	     DEST_XY,            dxy,
    	     SRC_XY,             ((srcy << 16) | srcx),
    	     CLIP_LeftT,         dxy,
    	     CLIP_RightB,        (dxy + wh) );
    geREG(   SRC_STRIDE_OFFSET,  (skipleft << 25));
    geREG(   DRAW_CMD,           pMQ->DrawCommand);	//make sure clip is on
}

#if 0   //FirstTest
	/***************************\
	|      Dashed  Lines        |
	\***************************/

void
MQSetupForDashedLine(
    ScrnInfoPtr pScrn, 
    int fg, int bg, int rop,
    unsigned int planemask,
    int length,
    unsigned char *pattern
)
{
    MGAPtr pMga = MGAPTR(pScrn);
    CARD32 *DashPattern = (CARD32*)pattern;
    CARD32 NiceDashPattern = DashPattern[0];
    int dwords = (length + 31) >> 5;

    pMga->DashCMD = MGADWG_BFCOL | pMga->AtypeNoBLK[rop];
    pMga->StyleLen = length - 1;

    if(bg == -1) {
        pMga->DashCMD |= MGADWG_TRANSC;
	WAITFIFO(dwords + 2);
    } else {
	WAITFIFO(dwords + 3);
	SET_BACKGROUND(bg);
    }
    SET_PLANEMASK(planemask);
    SET_FOREGROUND(fg);

    /* We see if we can draw horizontal lines as 8x8 pattern fills.
	This is worthwhile since the pattern fills can use block mode
	and the default X pattern is 8 pixels long.  The forward pattern
	is the top scanline, the backwards pattern is the next one. */
    switch(length) {
	case 2:	NiceDashPattern |= NiceDashPattern << 2;
	case 4:	NiceDashPattern |= NiceDashPattern << 4;
	case 8:	NiceDashPattern |= byte_reversed[NiceDashPattern] << 16;
		NiceDashPattern |= NiceDashPattern << 8;
		pMga->NiceDashCMD = MGADWG_TRAP | MGADWG_ARZERO | 
				    MGADWG_SGNZERO | MGADWG_BMONOLEF;
     		pMga->AccelFlags |= NICE_DASH_PATTERN;
   		if(bg == -1) {
#if PSZ == 24
    		   if(!RGBEQUAL(fg))
            		pMga->NiceDashCMD |= MGADWG_TRANSC | pMga->AtypeNoBLK[rop];
		   else
#endif
           		pMga->NiceDashCMD |= MGADWG_TRANSC | pMga->Atype[rop];
    		} else {
#if PSZ == 24
		   if((pMga->AccelFlags & BLK_OPAQUE_EXPANSION) && 
					RGBEQUAL(fg) && RGBEQUAL(bg)) 
#else
		   if(pMga->AccelFlags & BLK_OPAQUE_EXPANSION) 
#endif
        		pMga->NiceDashCMD |= pMga->Atype[rop];
		   else
        		pMga->NiceDashCMD |= pMga->AtypeNoBLK[rop];
    		}
		OUTREG(MGAREG_SRC0, NiceDashPattern);
		break;
	default: pMga->AccelFlags &= ~NICE_DASH_PATTERN;
		switch (dwords) {
		case 4:  OUTREG(MGAREG_SRC3, DashPattern[3]);
		case 3:  OUTREG(MGAREG_SRC2, DashPattern[2]);
		case 2:	 OUTREG(MGAREG_SRC1, DashPattern[1]);
		default: OUTREG(MGAREG_SRC0, DashPattern[0]);
		}
    }
}


static __inline__ CARD32* MoveDWORDS(
   register CARD32* dest,
   register CARD32* src,
   register int dwords
)
{
     while(dwords & ~0x03) {
        dest[0] = src[0];
        dest[1] = src[1];
        dest[2] = src[2];
        dest[3] = src[3];
        src += 4;
        dest += 4;
        dwords -= 4;
     }  

     if(!dwords) return(dest);
     dest[0] = src[0];
     if(dwords == 1) return(dest+1);
     dest[1] = src[1];
     if(dwords == 2) return(dest+2);
     dest[2] = src[2];
     return(dest+3);
}

void
MQWriteBitmapColorExpand(
    ScrnInfoPtr pScrn,
    int x, int y, int w, int h,
    unsigned char *src,
    int srcwidth,
    int skipleft,
    int fg, int bg,
    int rop,
    unsigned int planemask 
)
{
    MQPtr pMQ = MQPTR(pScrn);
    XAAInfoRecPtr infoRec = pMQ->AccelInfoRec;
    //CARD32* destptr = (CARD32*)infoRec->ColorExpandBase;
    CARD32* destptr = pMQ->IOBase + PSF_BASE;
    CARD32* maxptr;
    int dwords, maxlines, count;

    (*infoRec->SetupForCPUToScreenColorExpandFill)(
				pScrn, fg, bg, rop, planemask);

    w += skipleft;
    x -= skipleft;
    dwords = (w + 31) >> 5;
    maxlines = pMga->MaxBlitDWORDS / dwords;
    maxptr = destptr + infoRec->ColorExpandRange - dwords;
  
    while(h > maxlines) {
    	(*infoRec->SubsequentCPUToScreenColorExpandFill)
			(pScrn, x, y, w, maxlines, skipleft);
	count = maxlines;
	while(count--) {
	    WAITFIFO(dwords);
	    destptr = MoveDWORDS(destptr, (CARD32*)src, dwords);
	    src += srcwidth;
	    if(destptr > maxptr) 
		destptr = (CARD32*)infoRec->ColorExpandBase;
	}
	h -= maxlines;
	y += maxlines;
    }
    	
    (*infoRec->SubsequentCPUToScreenColorExpandFill)(
				pScrn, x, y, w, h, skipleft);

    while(h--) {
	WAITFIFO(dwords);
	destptr = MoveDWORDS(destptr, (CARD32*)src, dwords);
	src += srcwidth;
	if(destptr > maxptr) 
		destptr = (CARD32*)infoRec->ColorExpandBase;
    }
    DISABLE_CLIP();
    SET_SYNC_FLAG(infoRec);
}

void 
MQFillColorExpandRects(
   ScrnInfoPtr pScrn,
   int fg, int bg, int rop,
   unsigned int planemask,
   int nBox,
   BoxPtr pBox,
   int xorg, int yorg,
   PixmapPtr pPix
)
{
    MGAPtr pMga = MGAPTR(pScrn);
    XAAInfoRecPtr infoRec = pMga->AccelInfoRec;
    CARD32 *destptr, *maxptr;
    StippleScanlineProcPtr StippleFunc;
    unsigned char *src = (unsigned char*)pPix->devPrivate.ptr;
    int stipplewidth = pPix->drawable.width;
    int stippleheight = pPix->drawable.height;
    int srcwidth = pPix->devKind;
    int dwords, h, y, maxlines, count, srcx, srcy;
    unsigned char *srcp;

    if(stipplewidth <= 32) {
	if(stipplewidth & (stipplewidth - 1))	
	    StippleFunc = XAAStippleScanlineFuncLSBFirst[1];
	else	
	    StippleFunc = XAAStippleScanlineFuncLSBFirst[0];
    } else
    	StippleFunc = XAAStippleScanlineFuncLSBFirst[2];

    (*infoRec->SetupForCPUToScreenColorExpandFill)(
				pScrn, fg, bg, rop, planemask);

    while(nBox--) {
	dwords = (pBox->x2 - pBox->x1 + 31) >> 5;
	destptr = (CARD32*)infoRec->ColorExpandBase;
	maxptr = destptr + infoRec->ColorExpandRange - dwords;
	maxlines = pMga->MaxBlitDWORDS / dwords;
	y = pBox->y1;
	h = pBox->y2 - y;

	srcy = (pBox->y1 - yorg) % stippleheight;
	if(srcy < 0) srcy += stippleheight;
	srcx = (pBox->x1 - xorg) % stipplewidth;
	if(srcx < 0) srcx += stipplewidth;

	srcp = (srcwidth * srcy) + src;

	while(h > maxlines) {
           (*infoRec->SubsequentCPUToScreenColorExpandFill)(pScrn, 
			pBox->x1, y, pBox->x2 - pBox->x1, maxlines, 0);
	   count = maxlines;
	   while(count--) {
		WAITFIFO(dwords);
		destptr = (*StippleFunc)(
			destptr, (CARD32*)srcp, srcx, stipplewidth, dwords);
		if(destptr > maxptr) 
		    destptr = (CARD32*)infoRec->ColorExpandBase;
		srcy++;
		srcp += srcwidth;
		if (srcy >= stippleheight) {
		   srcy = 0;
		   srcp = src;
		}
	   }
	   h -= maxlines;
	   y += maxlines;
	} 

      	(*infoRec->SubsequentCPUToScreenColorExpandFill)(pScrn, 
			pBox->x1, y , pBox->x2 - pBox->x1, h, 0);

	while(h--) {
	    WAITFIFO(dwords);
	    destptr = (*StippleFunc)(
		destptr, (CARD32*)srcp, srcx, stipplewidth, dwords);
	    if(destptr > maxptr) 
		destptr = (CARD32*)infoRec->ColorExpandBase;
	    srcy++;
	    srcp += srcwidth;
	    if (srcy >= stippleheight) {
		srcy = 0;
		srcp = src;
	    }
	}

	pBox++;
    }
    DISABLE_CLIP();
    SET_SYNC_FLAG(infoRec);
}

void
MQNonTEGlyphRenderer(
   ScrnInfoPtr pScrn,
   int x, int y, int n,
   NonTEGlyphPtr glyphs,
   BoxPtr pbox,
   int fg, int rop,
   unsigned int planemask
)
{
    MQPtr pMQ = MQPTR(pScrn);
    XAAInfoRecPtr infoRec = pMQ->AccelInfoRec;
    int x1, x2, y1, y2, i, h, skiptop, dwords, maxlines;
    unsigned char *src;

    (*infoRec->SetupForCPUToScreenColorExpandFill)(
			pScrn, fg, -1, rop, planemask);
    WAITFIFO(1);
    OUTREG(MGAREG_CXBNDRY, ((pbox->x2 - 1) << 16) | pbox->x1);      
    pMga->AccelFlags |= CLIPPER_ON;

    for(i = 0; i < n; i++, glyphs++) {
	if(!glyphs->srcwidth) continue;

	y1 = y - glyphs->yoff;
	y2 = y1 + glyphs->height;
	if(y1 < pbox->y1) {
	    skiptop = pbox->y1 - y1;
	    y1 = pbox->y1;
	} else skiptop = 0;
	if(y2 > pbox->y2) y2 = pbox->y2;

	h = y2 - y1;
	if(h <= 0) continue;

	src = glyphs->bits + (skiptop * glyphs->srcwidth);

	dwords = glyphs->srcwidth >> 2;  /* dwords per line */
	x1 = x + glyphs->start;
	x2 = x1 + (dwords << 5);

	maxlines = min(pMga->MaxBlitDWORDS, infoRec->ColorExpandRange);
	maxlines /= dwords; 
     
	while(h > maxlines) {
	    WAITFIFO(4);
	    OUTREG(MGAREG_AR0, (dwords * maxlines << 5) - 1);
	    OUTREG(MGAREG_AR3, 0);
	    OUTREG(MGAREG_FXBNDRY, ((x2 - 1) << 16) | (x1 & 0xFFFF));
	    OUTREG(MGAREG_YDSTLEN + MGAREG_EXEC, (y1 << 16) | h);
	    WAITFIFO(dwords * maxlines);
	    MoveDWORDS((CARD32*)infoRec->ColorExpandBase, 
				(CARD32*)src, dwords * maxlines);
	    src += dwords * maxlines << 2;
	    h -= maxlines;
	    y1 += maxlines;
	}
    	
	dwords *= h; 	/* total dwords */
	WAITFIFO(4);
	OUTREG(MGAREG_AR0, (dwords << 5) - 1);
	OUTREG(MGAREG_AR3, 0);
	OUTREG(MGAREG_FXBNDRY, ((x2 - 1) << 16) | (x1 & 0xFFFF));
	OUTREG(MGAREG_YDSTLEN + MGAREG_EXEC, (y1 << 16) | h);
	WAITFIFO(dwords);
	MoveDWORDS((CARD32*)infoRec->ColorExpandBase, (CARD32*)src, dwords);
    }  

    DISABLE_CLIP();
    SET_SYNC_FLAG(infoRec);
}

void
MQValidatePolyArc(
   GCPtr 	pGC,
   unsigned long changes,
   DrawablePtr pDraw
){
   ScrnInfoPtr pScrn = xf86Screens[pGC->pScreen->myNum];
   MQPtr pMQ = MQPTR(pScrn);

   if((pMQ->AccelFlags & MGA_NO_PLANEMASK) && (pGC->planemask != ~0))
	return;

   if(!pGC->lineWidth && 
      (pGC->fillStyle == FillSolid) &&
      (pGC->lineStyle == LineSolid) &&
      ((pGC->alu != GXcopy) || (pGC->planemask != ~0) ||
		(pScrn->bitsPerPixel == 24))) {
	pGC->ops->PolyArc = MGAPolyArcThinSolid;
   }
}

static void
MQPolyPoint (
    DrawablePtr pDraw,
    GCPtr pGC,
    int mode,	
    int npt,
    xPoint *ppt
){
    int numRects = REGION_NUM_RECTS(pGC->pCompositeClip);
    XAAInfoRecPtr infoRec;
    BoxPtr pbox;
    MGAPtr pMga;
    int xorg, yorg;

    if(!numRects) return;
    
    if(numRects != 1) {
	XAAFallbackOps.PolyPoint(pDraw, pGC, mode, npt, ppt);
	return;
    }

    infoRec = GET_XAAINFORECPTR_FROM_GC(pGC);
    pMga = MGAPTR(infoRec->pScrn);
    xorg = pDraw->x;
    yorg = pDraw->y;

    pbox = REGION_RECTS(pGC->pCompositeClip);

    (*infoRec->SetClippingRectangle)(infoRec->pScrn,
                pbox->x1, pbox->y1, pbox->x2 - 1, pbox->y2 - 1);
    (*infoRec->SetupForSolidFill)(infoRec->pScrn, pGC->fgPixel, pGC->alu,
				   pGC->planemask);

    if(mode == CoordModePrevious)
    {
	while(npt--)
        {
	    xorg += ppt->x;
	    yorg += ppt->y;
	    WAITFIFO(2);
	    OUTREG(MGAREG_FXBNDRY, ((xorg + 1) << 16) | (xorg & 0xffff));
	    OUTREG(MGAREG_YDSTLEN + MGAREG_EXEC, (yorg << 16) | 1);
	    ppt++;
	} 
    } else {
	int x;
	while(npt--) {
	    x = ppt->x + xorg;
	    WAITFIFO(2);
	    OUTREG(MGAREG_FXBNDRY, ((x + 1) << 16) | (x & 0xffff));
	    OUTREG(MGAREG_YDSTLEN + MGAREG_EXEC, ((ppt->y + yorg) << 16) | 1);
	    ppt++;
	}
    }
    
    (*infoRec->DisableClipping)(infoRec->pScrn);
  
    SET_SYNC_FLAG(infoRec);
}


void
MQValidatePolyPoint(
   GCPtr 	pGC,
   unsigned long changes,
   DrawablePtr pDraw
)
{
   ScrnInfoPtr pScrn = xf86Screens[pGC->pScreen->myNum];
   MQPtr pMQ = MQPTR(pScrn);

   pGC->ops->PolyPoint = XAAFallbackOps.PolyPoint;

   if((pMga->AccelFlags & MGA_NO_PLANEMASK) && (pGC->planemask != ~0))
	return;

   if((pGC->alu != GXcopy) || (pGC->planemask != ~0) || 
					(pScrn->bitsPerPixel == 24))
	pGC->ops->PolyPoint = MGAPolyPoint;
}


void 
MQFillCacheBltRects(
   ScrnInfoPtr pScrn,
   int rop,
   unsigned int planemask,
   int nBox,
   BoxPtr pBox,
   int xorg, int yorg,
   XAACacheInfoPtr pCache
){
    XAAInfoRecPtr infoRec = GET_XAAINFORECPTR_FROM_SCRNINFOPTR(pScrn);
    int x, y, phaseY, phaseX, skipleft, height, width, w, blit_w, blit_h, start;

    (*infoRec->SetupForScreenToScreenCopy)(pScrn, 1, 1, rop, planemask,
		pCache->trans_color);

    while(nBox--) {
	y = pBox->y1;
	phaseY = (y - yorg) % pCache->orig_h;
	if(phaseY < 0) phaseY += pCache->orig_h;
	phaseX = (pBox->x1 - xorg) % pCache->orig_w;
	if(phaseX < 0) phaseX += pCache->orig_w;
	height = pBox->y2 - y;
	width = pBox->x2 - pBox->x1;
	start = phaseY ? (pCache->orig_h - phaseY) : 0;

	/* This is optimized for WRAM */
	
	if ((rop == GXcopy) && (height >= (pCache->orig_h + start))) {		
	    w = width; skipleft = phaseX; x = pBox->x1;
	    blit_h = pCache->orig_h;
	
	    while(1) {
		blit_w = pCache->w - skipleft;
		if(blit_w > w) blit_w = w;
		(*infoRec->SubsequentScreenToScreenCopy)(pScrn,
			pCache->x + skipleft, pCache->y,
			x, y + start, blit_w, blit_h);
		w -= blit_w;
		if(!w) break;
		x += blit_w;
		skipleft = (skipleft + blit_w) % pCache->orig_w;
	    }
	    height -= blit_h;

	    if(start) {
		(*infoRec->SubsequentScreenToScreenCopy)(pScrn,
			pBox->x1, y + blit_h, pBox->x1, y, width, start);
		height -= start;
		y += start;
	    }
	    start = blit_h;
	
	    while(height) {
		if(blit_h > height) blit_h = height;
		(*infoRec->SubsequentScreenToScreenCopy)(pScrn,
			pBox->x1, y,
			pBox->x1, y + start, width, blit_h);
		height -= blit_h;
		start += blit_h;
		blit_h <<= 1;
	    }
	} else {
	    while(1) {
		w = width; skipleft = phaseX; x = pBox->x1;
		blit_h = pCache->h - phaseY;
		if(blit_h > height) blit_h = height;
	
		while(1) {
		    blit_w = pCache->w - skipleft;
		    if(blit_w > w) blit_w = w;
		    (*infoRec->SubsequentScreenToScreenCopy)(pScrn,
			pCache->x + skipleft, pCache->y + phaseY,
			x, y, blit_w, blit_h);
		    w -= blit_w;
		    if(!w) break;
		    x += blit_w;
		    skipleft = (skipleft + blit_w) % pCache->orig_w;
		}
		height -= blit_h;
		if(!height) break;
		y += blit_h;
		phaseY = (phaseY + blit_h) % pCache->orig_h;
	    }
	}
	pBox++;
    }
    
    SET_SYNC_FLAG(infoRec);
}

void 
MQTEGlyphRenderer(
    ScrnInfoPtr pScrn,
    int x, int y, int w, int h, int skipleft, int startline, 
    unsigned int **glyphs, int glyphWidth,
    int fg, int bg, int rop, unsigned planemask
){
    XAAInfoRecPtr infoRec = GET_XAAINFORECPTR_FROM_SCRNINFOPTR(pScrn);
    GlyphScanlineFuncPtr GlyphFunc = 
			XAAGlyphScanlineFuncLSBFirst[glyphWidth - 1];
    MGAPtr pMga = MGAPTR(pScrn);
    CARD32* base;
    int dwords;

    (*infoRec->SetupForCPUToScreenColorExpandFill)(
				pScrn, fg, bg, rop, planemask);

    w += skipleft;
    x -= skipleft;
    dwords = (w + 31) >> 5;

    (*infoRec->SubsequentCPUToScreenColorExpandFill)(
				pScrn, x, y, w, h, skipleft);

    base = (CARD32*)infoRec->ColorExpandBase;

    if((dwords * h) <= infoRec->ColorExpandRange)
	while(h--) {
	    WAITFIFO(dwords);
	    base = (*GlyphFunc)(base, glyphs, startline++, w, glyphWidth);
	}
    else
	while(h--) {
	    WAITFIFO(dwords);
	    (*GlyphFunc)(base, glyphs, startline++, w, glyphWidth);
	}

    DISABLE_CLIP();
    SET_SYNC_FLAG(infoRec);
}
#endif	//FirstTest

#if 0   //def XF86DRI
void
MQDRIInitBuffers(WindowPtr pWin, RegionPtr prgn, CARD32 index)
{
  ScreenPtr pScreen = pWin->drawable.pScreen;
  ScrnInfoPtr pScrn = xf86Screens[pScreen->myNum];
  MQPtr pMQ = MQPTR(pScrn);
  BoxPtr pbox;
  int nbox;

  /* It looks nicer if these start out black */
  pbox = REGION_RECTS(prgn);
  nbox = REGION_NUM_RECTS(prgn);

  MQSetupForSolidFill(pScrn, 0, GXcopy, -1);
  while (nbox--) {
    //MQSelectBuffer(pMQ, MQ_BACK);
    MQSubsequentSolidFillRect(pScrn, pbox->x1, pbox->y1,
			pbox->x2-pbox->x1, pbox->y2-pbox->y1);
    //MQSelectBuffer(pMQ, MQ_DEPTH);
    MQSubsequentSolidFillRect(pScrn, pbox->x1, pbox->y1,
			pbox->x2-pbox->x1, pbox->y2-pbox->y1);
    pbox++;
  }
  //MQSelectBuffer(pMQ, MQ_FRONT);

  pMQ->AccelInfoRec->NeedToSync = TRUE;
}

/*
  This routine is a modified form of XAADoBitBlt with the calls to
  ScreenToScreenBitBlt built in. My routine has the prgnSrc as source
  instead of destination. My origin is upside down so the ydir cases
  are reversed.
*/
	   
void
MQDRIMoveBuffers(WindowPtr pParent, DDXPointRec ptOldOrg, 
		   RegionPtr prgnSrc, CARD32 index)
{
#if 0
  ScreenPtr pScreen = pParent->drawable.pScreen;
  ScrnInfoPtr pScrn = xf86Screens[pScreen->myNum];
  MGAPtr pMGA = MGAPTR(pScrn);
  int nbox;
  BoxPtr pbox, pboxTmp, pboxNext, pboxBase, pboxNew1, pboxNew2;
  DDXPointPtr pptTmp, pptNew1, pptNew2;
  int xdir, ydir;
  int dx, dy, w, h;
  DDXPointPtr pptSrc;

  pbox = REGION_RECTS(prgnSrc);
  nbox = REGION_NUM_RECTS(prgnSrc);
  pboxNew1 = 0;
  pptNew1 = 0;
  pboxNew2 = 0;
  pboxNew2 = 0;
  pptSrc = &ptOldOrg;

  dx = pParent->drawable.x - ptOldOrg.x;
  dy = pParent->drawable.y - ptOldOrg.y;

  /* If the copy will overlap in Y, reverse the order */
  if (dy>0) {
    ydir = -1;

    if (nbox>1) {
      /* Keep ordering in each band, reverse order of bands */
      pboxNew1 = (BoxPtr)ALLOCATE_LOCAL(sizeof(BoxRec)*nbox);
      if (!pboxNew1) return;
      pptNew1 = (DDXPointPtr)ALLOCATE_LOCAL(sizeof(DDXPointRec)*nbox);
      if (!pptNew1) {
	DEALLOCATE_LOCAL(pboxNew1);
	return;
      }
      pboxBase = pboxNext = pbox+nbox-1;
      while (pboxBase >= pbox) {
	while ((pboxNext >= pbox) && (pboxBase->y1 == pboxNext->y1))
	  pboxNext--;
	pboxTmp = pboxNext+1;
	pptTmp = pptSrc + (pboxTmp - pbox);
	while (pboxTmp <= pboxBase) {
	  *pboxNew1++ = *pboxTmp++;
	  *pptNew1++ = *pptTmp++;
	}
	pboxBase = pboxNext;
      }
      pboxNew1 -= nbox;
      pbox = pboxNew1;
      pptNew1 -= nbox;
      pptSrc = pptNew1;
    }
  } else {
    /* No changes required */
    ydir = 1;
  }

  /* If the regions will overlap in X, reverse the order */
  if (dx>0) {
    xdir = -1;

    if (nbox > 1) {
      /*reverse orderof rects in each band */
      pboxNew2 = (BoxPtr)ALLOCATE_LOCAL(sizeof(BoxRec)*nbox);
      pptNew2 = (DDXPointPtr)ALLOCATE_LOCAL(sizeof(DDXPointRec)*nbox);
      if (!pboxNew2 || !pptNew2) {
	if (pptNew2) DEALLOCATE_LOCAL(pptNew2);
	if (pboxNew2) DEALLOCATE_LOCAL(pboxNew2);
	if (pboxNew1) {
	  DEALLOCATE_LOCAL(pptNew1);
	  DEALLOCATE_LOCAL(pboxNew1);
	}
	return;
      }
      pboxBase = pboxNext = pbox;
      while (pboxBase < pbox+nbox) {
	while ((pboxNext < pbox+nbox) && (pboxNext->y1 == pboxBase->y1))
	  pboxNext++;
	pboxTmp = pboxNext;
	pptTmp = pptSrc + (pboxTmp - pbox);
	while (pboxTmp != pboxBase) {
	  *pboxNew2++ = *--pboxTmp;
	  *pptNew2++ = *--pptTmp;
	}
	pboxBase = pboxNext;
      }
      pboxNew2 -= nbox;
      pbox = pboxNew2;
      pptNew2 -= nbox;
      pptSrc = pptNew2;
    }
  } else {
    /* No changes are needed */
    xdir = 1;
  }
  
  MQFUNC(SetupForScreenToScreenCopy)(pScrn, xdir, ydir, GXcopy, -1, -1);
  while (nbox--) {
    w=pbox->x2-pbox->x1+1;
    h=pbox->y2-pbox->y1+1;
    MGASelectBuffer(pMGA, MGA_BACK);
    MQFUNC(SubsequentScreenToScreenCopy)(pScrn, pbox->x1, pbox->y1, 
				     pbox->x1+dx, pbox->y1+dy, w, h);
    MGASelectBuffer(pMGA, MGA_DEPTH);
    MQFUNC(SubsequentScreenToScreenCopy)(pScrn, pbox->x1, pbox->y1, 
				     pbox->x1+dx, pbox->y1+dy, w, h);
    pbox++;
  }
  MGASelectBuffer(pMGA, MGA_FRONT);

  if (pboxNew2) {
    DEALLOCATE_LOCAL(pptNew2);
    DEALLOCATE_LOCAL(pboxNew2);
  }
  if (pboxNew1) {
    DEALLOCATE_LOCAL(pptNew1);
    DEALLOCATE_LOCAL(pboxNew1);
  }

  pMGA->AccelInfoRec->NeedToSync = TRUE;M
#endif
}
#endif //FirstTest /* XF86DRI */
